# 稿定公共业务组件库

## 起步

:::tip 依赖
vue version > 2.5
:::

###  安装
yarn
```bash
yarn add @gaoding/gd-components
```
npm
```bash
npm install -S @gaoding/gd-components
```

:::warning
如果是使用webpack等打包工具方式, 注意不要忽略对gd-components打包
因为**gd-components**提供的是后编译的环境, 从而减少项目最终打包体积
:::


### 打包工具使用方式使用

**注入所有组件**
```JavaScript
import gdui from '@gaoding/gd-components';
import vue from 'vue';

vue.use(gdui);
```
### 按需引用方式

```vue
<template>
    <account-dialog></account-dialog>
</template>
<script>
import { AccountDialog } from '@gaoding/gd-components';
export defalut {
    components: { AccountDialog }
};
</script>
```

### UMD方式引用
::: tip
umd的相关资源都在 `dist` 目录下,另外 使用umd方式, 会自动全局注册gdui的所有组件
:::

```html
<link rel="stylesheet" media="all" href="./dist/gdui.css">
<script src="./lib/vue.min.js"></script>
<script src="./dist/gdui.umd.min.js"></script>
```