import { shallowMount } from '@vue/test-utils';
import Button from '../';

describe('Button', () => {
    test('render text', () => {
        // 渲染这个组件
        const wrapper = shallowMount(Button, {
            slots: {
                default: 'test'
            }
        });

        expect(wrapper.element).toMatchSnapshot();
        expect(wrapper.text()).toEqual('test');
    });

    test('render primary button', () => {
        const wrapper = shallowMount(Button, {
            propsData: {
                type: 'primary'
            },
        });
        expect(wrapper.element).toMatchSnapshot();
        expect(wrapper.contains('.gd-button--primary')).toBe(true);
    });
});
