/*
 * @Author: lijianzhang
 * @Date: 2018-03-07 23:50:36
 * @Last Modified by: lijianzhang
 * @Last Modified time: 2019-02-18 21:10:09
 */
import Vue from 'vue';
import Message from './Message';

const MessageVue = Vue.extend(Message);

function message(options) {
    const vm = new MessageVue();

    Object.assign(vm, {
        ...options,
        onClose() {
            vm.$destroy();
            if (vm.$el && vm.$el.parentNode) vm.$el.parentNode.removeChild(vm.$el);
        } });
    vm.$mount();
    window.vm = vm;
    vm.visible = true;
    return () => {
        if (vm.visible) {
            vm.visible = false;
        }
    };
}

['alert', 'warn', 'success', 'info', 'trash'].forEach((key) => {
    Message[key] = (m, props) => {
        return message({
            message: m,
            width: '350px',
            ...props,
            type: key,
        });
    };
});

export default Message;

Vue.prototype.$message = Message;
