import VideoDialog from '../VideoDialog';
import Vue from 'vue';

let currentMsg = null;

function defaultCallback(action) {
    if (!action) {
        currentMsg.reject();
    }
    currentMsg.resolve();
}


export default function createVideo(params) {
    let video = null;
    const VideoConstructor = Vue.extend(VideoDialog);

    VideoConstructor.prototype.callback = defaultCallback;

    if (!video) {
        video = new VideoConstructor().$mount();
        document.body.appendChild(video.$el);
        document.documentElement.style.overflow = 'hidden';
    }
    // params: 暂时只传url
    const { url, autoplay, loop } = params;

    video.url = url;
    video.visible = true;
    video.autoplay = autoplay || false;
    video.loop = loop || false;

    return new Promise((resolve, reject) => {
        currentMsg = { resolve, reject };
    });
};
