
import Auth from './Auth';
import AuthModal from './AuthModal';
import Badge from './Badge';
import Button from './Button';
import EditorHelp from './EditorHelp';
import EditorSidebar from './EditorSidebar';
import FeedbackModal from './FeedbackModal';
import Filter from './Filter';
import Footer from './Footer';
import Header from './Header';
import Icon from './Icon';
import Input from './Input';
import LazyImage from './LazyImage';
import LoadMore from './LoadMore';
import Menu from './Menu';
import MenuItem from './MenuItem';
import Message from './Message';
import Modal from './Modal';
import Navigation from './Navigation';
import Pagination from './Pagination';
import Popover from './Popover';
import Portal from './Portal';
import Progress from './Progress';
import QuickLink from './QuickLink';
import Rate from './Rate';
import Select from './Select';
import SubMenu from './SubMenu';
import TabPanel from './TabPanel';
import Tabs from './Tabs';
import Tips from './Tips';
import Tooltip from './Tooltip';
import Udesk from './Udesk';
import Upload from './Upload';
import UserPreference from './UserPreference';
import VideoDialog from './VideoDialog';
import Waterfall from './Waterfall';
import cache from './cache';
import config from './config';
import confim from './confim';
import createVideo from './createVideo';
import guestUser from './guestUser';
import oss from './oss';
import questionnaire from './questionnaire';
import request from './request';

export { default as Auth } from './Auth';
export { default as AuthModal } from './AuthModal';
export { default as Badge } from './Badge';
export { default as Button } from './Button';
export { default as EditorHelp } from './EditorHelp';
export { default as EditorSidebar } from './EditorSidebar';
export { default as FeedbackModal } from './FeedbackModal';
export { default as Filter } from './Filter';
export { default as Footer } from './Footer';
export { default as Header } from './Header';
export { default as Icon } from './Icon';
export { default as Input } from './Input';
export { default as LazyImage } from './LazyImage';
export { default as LoadMore } from './LoadMore';
export { default as Menu } from './Menu';
export { default as MenuItem } from './MenuItem';
export { default as Message } from './Message';
export { default as Modal } from './Modal';
export { default as Navigation } from './Navigation';
export { default as Pagination } from './Pagination';
export { default as Popover } from './Popover';
export { default as Portal } from './Portal';
export { default as Progress } from './Progress';
export { default as QuickLink } from './QuickLink';
export { default as Rate } from './Rate';
export { default as Select } from './Select';
export { default as SubMenu } from './SubMenu';
export { default as TabPanel } from './TabPanel';
export { default as Tabs } from './Tabs';
export { default as Tips } from './Tips';
export { default as Tooltip } from './Tooltip';
export { default as Udesk } from './Udesk';
export { default as Upload } from './Upload';
export { default as UserPreference } from './UserPreference';
export { default as VideoDialog } from './VideoDialog';
export { default as Waterfall } from './Waterfall';
export { default as cache } from './cache';
export { default as config } from './config';
export { default as confim } from './confim';
export { default as createVideo } from './createVideo';
export { default as guestUser } from './guestUser';
export { default as oss } from './oss';
export { default as questionnaire } from './questionnaire';
export { default as request } from './request';

const components = {
    Auth,
    AuthModal,
    Badge,
    Button,
    EditorHelp,
    EditorSidebar,
    FeedbackModal,
    Filter,
    Footer,
    Header,
    Icon,
    Input,
    LazyImage,
    LoadMore,
    Menu,
    MenuItem,
    Message,
    Modal,
    Navigation,
    Pagination,
    Popover,
    Portal,
    Progress,
    QuickLink,
    Rate,
    Select,
    SubMenu,
    TabPanel,
    Tabs,
    Tips,
    Tooltip,
    Udesk,
    Upload,
    UserPreference,
    VideoDialog,
    Waterfall,
    cache,
    config,
    confim,
    createVideo,
    guestUser,
    oss,
    questionnaire,
    request,
    
};

export function install(Vue) {
    Object.keys(components).forEach(key => {
        if (components[key].install) {
            Vue.use(components[key]);
        } else if (components[key].name) {
            Vue.component(components[key].name, components[key])
        }
    })
  }  
const gdui = {
    install,
    ...components
};

export default gdui;

let GlobalVue = null;

if (typeof window !== 'undefined') {
    GlobalVue = window.Vue;
}

else if (typeof global !== 'undefined') {
    GlobalVue = global.Vue;
}

if (GlobalVue) {
    install(GlobalVue);
}